Java version mismatching causes SAI failure
Status: Closed Start date: Jun 14, 2017

Priority: Immediate Due date:  

Assignee: _InfraScience Systems Engineer % Done: 100%

Category: High-Throughput-Computing Estimated time: 0.00 hour

Target version: Migrating to Java 8   

Infrastructure: Production   

Description

The Portals have been passed to Java 8 but the DataMiners have not (although I was suppose to have tested this in #8424).

Unfortunately, SAI compiles Java processes and prepares them for installation on the DataMiners. Since the portal's Java version is

higher, all the newly integrated SAI processes cannot work now on the DataMiners.

This means that at the current stage SAI does not work. The misalignment should be solved asap somehow, since we are plenty of

SAI requests.

Related issues:

Related to D4Science Infrastructure - Task #8953: Update Jdk on all dataminer... Closed Jun 14, 2017

History

#1 - Jun 14, 2017 01:18 PM - Andrea Dell'Amico

java 7 is still available on the portals VMs. It lives into /usr/lib/jvm/java-7-oracle (that's JAVA_HOME). The binaries (java, javac, etc.) live in

/usr/lib/jvm/java-7-oracle/bin

#2 - Jun 14, 2017 01:19 PM - Andrea Dell'Amico

The alternative is switch to java8 on all the dataminers.

#3 - Jun 14, 2017 01:49 PM - Massimiliano Assante

org.gcube.portlets.user.statistical-algorithms-importer.1-6-0 (common apps) was tested by @etheodorako@di.uoa.gr on Jun 01, 2017 11:32 AM. 

Preprod1 and 2 have been running with Java8 since May 24th. So either the Data miner preprod instance is running Java8 or there is a problem in

the testing plan. 

Sorry, I'm just trying to understand why we didn't catch this problem so that we can improve.

@mariaantonietta.digirolamo@eng.it @g.panichi@isti.cnr.it 

#5 - Jun 14, 2017 02:13 PM - Andrea Dell'Amico

dataminer1-pre.d4science.org is running java 7, java 8 is not installed.

#6 - Jun 14, 2017 03:37 PM - Massimiliano Assante

@g.panichi@isti.cnr.it is one or more steps of the testing plan of SAI covering the test regarding this issue?

#7 - Jun 14, 2017 03:42 PM - Giancarlo Panichi

Please is it possible to put a dataminer in production with Java 8 on RPrototypingLab, so let's take a look and I see if it can work with java 8 (In

GCube 4.5 release should have been brought to Java 8)

#8 - Jun 14, 2017 03:57 PM - Massimiliano Assante

- Status changed from New to In Progress

The SAI Testing plan does not cover the actual publication part of the SAI Algorithm produced, if it did then we would have spotted the problem a

while ago. @mariaantonietta.digirolamo@eng.it can you make sure the developer modifies the SAI Testing plan including this test case for the future?

as for fixing the problem now i guess there is not other way than upgrading the Java version on production data miner instances

@roberto.cirillo@isti.cnr.it ?
#9 - Jun 14, 2017 04:16 PM - Giancarlo Panichi

Meanwhile, I am creating a version of SAI that compiles in Java 7 to solve the problem if it is not possible to switch dataminer service to Java 8 

#10 - Jun 14, 2017 04:21 PM - Massimiliano Assante

Giancarlo Panichi wrote:

Meanwhile, I am creating a version of SAI that compiles in Java 7 to solve the problem

 I don't think this would solve the problem for the already submitted algorithms, am I wrong?

#11 - Jun 14, 2017 04:34 PM - Gianpaolo Coro

We can ask for a new publication.

#12 - Jun 14, 2017 04:35 PM - Roberto Cirillo

From this ticket #8424 seems all works well with Java8. So, I think we should upgrade the jdk on preproduction dataminer instance and test it with the

SAI portlet. If all works we could also upgrade the jdk  on RPrototypingLab VRE and so on all production instances. 

#13 - Jun 14, 2017 04:41 PM - Gianpaolo Coro

That ticket reports my tests towards a Dataminer that was DECLARED to be java 8 but indeed I have later discovered it was java 7 actually. Thus, the

ticket and my tests were useless.

#14 - Jun 14, 2017 04:47 PM - Massimiliano Assante

- % Done changed from 0 to 20

I would avoid to double the work, if Giancarlo is working on the SAI compiling Java7 re-deplying the portlet isn't a big issue.

@costantino.perciante@isti.cnr.it can do it if you provide the tar.gz to him. And after the last Gianpaol's comment I guess it would be even "safer".

#15 - Jun 14, 2017 04:53 PM - Andrea Dell'Amico

Well, I was asked about dataminer1-pre, but from the other ticket I see that the test were made on dataminer[1:2]-d-d4s.d4science.org. And those

were running jdk 8.

We cannot use those VMs for another set of tests because they are running the new dataminer developed by @lucio.lelii@isti.cnr.it 

#16 - Jun 14, 2017 05:58 PM - Giancarlo Panichi

I tested dataminer1-pre with java 8 and SAI with java 8. In pre-production the basic tests have been successful. To verify that all algorithms are

working with java 8 it is necessary to hook dataminer1-pre to production so @gianpaolo.coro@isti.cnr.it  can finally verify that all algorithms work.

#17 - Jun 14, 2017 06:08 PM - Roberto Cirillo

dataminer1-pre is running now on RPrototypingLab

#18 - Jun 14, 2017 06:38 PM - Gianpaolo Coro

The tests worked fine.

#19 - Jun 14, 2017 06:59 PM - Roberto Cirillo

- Status changed from In Progress to Closed

- % Done changed from 20 to 100

I've update the jdk to jdk8 in the prototypes and genericworkers-proto clusters. I've also restored dataminer1-pre in preprod environment. So, I think

this ticket can be closed now.

I'm going to open another ticket for updating the jdk on the other production clusters.

#20 - Jun 14, 2017 07:04 PM - Roberto Cirillo

- Related to Task #8953: Update Jdk on all dataminer instances added
